      program convert
**********************************************************************
*                                                                    *
*                          GERHARD WOTAWA                            *
*                          1999-07-16                                *
*                                                                    *
**********************************************************************
*                                                                    *
* This program converts MM5 output into FLEXPART format (ECMWF grib  *
* code)                                                              *
* Please specify in the file "CONTROL"                               *
*                                                                    *
* - how many nest levels you use                                     *
* - where your input is available                                    *
* - where your output shall be written to                            *
* - The first 2 symbols of your output files                         *
*                                                                    *
* Please specify in the file PARAMETER which MM5 parameter (2D, 3D)  *
* shall be extracted, and what number shall they get in the grib     *
* file (most user should not change that stuff anyway...)            *
*                                                                    *
* Compile: DEC ALPHA: f77 -convert big_endian *.f                    *
*          SUN, SGI:  f77 *.f                                        *
*                                                                    *
**********************************************************************
      implicit none
      include 'inclpar'
      include 'inclcom'
      integer numnest,inest,numpar2d,numpar3d,ipar,len,iunit,ident
      integer numfile,ifile,inum,num0d,num1d,num2d,num3d
      integer inumfirst(maxnest),jmd,hms,jmdrestart,hmsrestart
      integer i,j,k,ifield,ifieldskip,lenp
      real xlow,ylow,xup,yup
      character fid*2,cnum*2,syscom*150
      character*120 fnmm5(maxnest,maxfile),pathout(maxnest)
      logical err,eof
      double precision juldate,julstart,julsum,deljul,julrestart

      write(*,*) 'CONVERT MM5 OUTPUT TO FLEXPART_MM5 FORMAT'
      write(*,*)

* OPEN CONTROL FILE TO SEE WHAT TO DO...

      open(41,file='CONTROL',status='old',err=999)
      read(41,*,end=999,err=999) numnest
      if (numnest.gt.maxnest) then
        write(*,20)    'INCREASE VARIABLE maxnest FROM ',maxnest
        write(*,21)    'TO ',numnest,' IN FILE inclpar'
        write(*,'(a)') 'AND RECOMPILE...'
        stop
      endif
      read(41,*,end=999,err=999) numfile
      if (numfile.gt.maxfile) then
        write(*,20)    'INCREASE VARIABLE maxfile FROM ',maxfile
        write(*,21)    'TO ',numfile,' IN FILE inclpar'
        write(*,'(a)') 'AND RECOMPILE...'
        stop
      endif
      read(41,*,end=999,err=999)
      read(41,*,end=999,err=999)
      read(41,*,end=999,err=999)
      write(*,*)
      write(*,'(a)') 'INPUT DATA: '
      write(*,*)
      do 10 inest=1,numnest
        write(*,'(a,i2)') 'MM5 DATA DOMAIN ',inest
        do 10 ifile=1,numfile
          read(41,'(a)',end=999,err=999) fnmm5(inest,ifile)
10        write(*,'(i3,2x,a)') ifile,fnmm5(inest,ifile)
      read(41,*,end=999,err=999)
      read(41,*,end=999,err=999)
      read(41,*,end=999,err=999)
      write(*,*)
      write(*,'(a)') 'OUTPUT DATA: '
      write(*,*)
      do 15 inest=1,numnest
        read(41,'(a)',end=999,err=999) pathout(inest)
        write(*,'(a,i2)') 'CONVERTED DATA DOMAIN ',inest
15      write(*,'(a)') pathout(inest)
      read(41,*,end=999,err=999)
      read(41,*,end=999,err=999)
      read(41,*,end=999,err=999)
      read(41,'(a)',end=999,err=999) fid
      read(41,*,end=999,err=999)
      read(41,'(10x,i6)',end=999,err=999) ifieldskip
      close(41)
20    format(a,i3)
21    format(a,i3,a)

* OPEN PARAMETER FILE TO SEE WHAT OUTPUT QUANTITIES ARE NEEDED...

      open(41,file='PARAMETER',status='old',err=998)
      read(41,*,end=998,err=998)
      read(41,*,end=998,err=998)
      read(41,*,end=998,err=998) numpar3d
      if (numpar3d.gt.maxpar3d) then
        write(*,20)    'INCREASE VARIABLE maxpar3d FROM ',maxpar3d
        write(*,21)    'TO ',numpar3d,' IN FILE inclpar'
        write(*,'(a)') 'AND RECOMPILE...'
        stop
      endif
      read(41,*,end=998,err=998)
      read(41,*,end=998,err=998)
      read(41,*,end=998,err=998)
      do 25 ipar=1,numpar3d
        read(41,30,end=998,err=998) mm5name3d(ipar),igribnum3d(ipar),
     &    cdot3d(ipar),cacc3d(ipar),unitmm53d(ipar),unitflex3d(ipar),
     &    rfac3d(ipar),comment3d(ipar)
25      write(*,30) mm5name3d(ipar),igribnum3d(ipar),
     &    cdot3d(ipar),cacc3d(ipar),unitmm53d(ipar),unitflex3d(ipar),
     &    rfac3d(ipar),comment3d(ipar)
      read(41,*,end=998,err=998)
      read(41,*,end=998,err=998) numpar2d
      if (numpar2d.gt.maxpar2d) then
        write(*,20)    'INCREASE VARIABLE maxpar2d FROM ',maxpar2d
        write(*,21)    'TO ',numpar2d,' IN FILE inclpar'
        write(*,'(a)') 'AND RECOMPILE...'
        stop
      endif
      read(41,*,end=998,err=998)
      read(41,*,end=998,err=998)
      read(41,*,end=998,err=998)
      do 26 ipar=1,numpar2d
        read(41,30,end=998,err=998) mm5name2d(ipar),igribnum2d(ipar),
     &    cdot2d(ipar),cacc2d(ipar),unitmm52d(ipar),unitflex2d(ipar),
     &    rfac2d(ipar),comment2d(ipar)
26      write(*,30) mm5name2d(ipar),igribnum2d(ipar),
     &    cdot2d(ipar),cacc2d(ipar),unitmm52d(ipar),unitflex2d(ipar),
     &    rfac2d(ipar),comment2d(ipar)
      close(41)
30    format(a11,i3,5x,a1,5x,a1,2x,2a12,f8.3,1x,a19)

* LINK INPUT DATA TO FORTRAN UNITS 60 PLUS 

      call system('rm fort.15')
      write(*,*)
      inum=0
      do 40 inest=1,numnest
        do 40 ifile=1,numfile
          inum=inum+1
          len=index(fnmm5(inest,ifile),' ')-1
          write(cnum,'(i2.2)') 60+inum
          if(ifile.eq.1) inumfirst(inest)=60+inum
          syscom='rm fort.'//cnum
          call system(syscom)
          syscom='ln -s '//fnmm5(inest,ifile)(1:len)//
     &      ' fort.'//cnum
          len=index(syscom,'  ')-1
          write(*,'(a)') syscom(1:len)
40        call system(syscom)

* MAKE A LOOP FROM DOMAIN 1 TO DOMAIN NUMNEST

      inum=0
      do 1000 inest=1,numnest

        write(*,*)
        write(*,'(a,i2)') 'START CONVERSION FOR DOMAIN ',inest
        iunit=inumfirst(inest)
        read(iunit,end=997,err=997) mif,mrf,mifc,mrfc

        ident=mif(1,1)
        if(ident.ne.6) goto 996   !!! This is NO MM5 output !!!
        if(mif(5,6).ne.1) goto 995 !!! This is a hydrostatic run !!!

* READ DIMENSIONS

        IX = MIF(104,1)
        if(ix.gt.nxmm5) then
          write(*,20)    'INCREASE VARIABLE nxmm5 FROM ',nxmm5
          write(*,21)    'TO ',ix,' IN FILE inclpar'
          write(*,'(a)') 'AND RECOMPILE...'
          stop
        endif
        JX = MIF(105,1)
        if(jx.gt.nymm5) then
          write(*,20)    'INCREASE VARIABLE nymm5 FROM ',nymm5
          write(*,21)    'TO ',jx,' IN FILE inclpar'
          write(*,'(a)') 'AND RECOMPILE...'
          stop
        endif
        KX = INT(MRF(101,6))
        if(kx.gt.nzmax) then
          write(*,20)    'INCREASE VARIABLE nzmax FROM ',nzmax
          write(*,21)    'TO ',kx,' IN FILE inclpar'
          write(*,'(a)') 'AND RECOMPILE...'
          stop
        endif
        NUM3D = MIF(201,ident)
        if(num3d.gt.max3dmm5) then
          write(*,20)    'INCREASE VARIABLE max3dmm5 FROM ',max3dmm5
          write(*,21)    'TO ',num3d,' IN FILE inclpar'
          write(*,'(a)') 'AND RECOMPILE...'
          stop
        endif
        NUM2D = MIF(202,ident)
        if(num2d.gt.max2dmm5) then
          write(*,20)    'INCREASE VARIABLE max2dmm5 FROM ',max2dmm5
          write(*,21)    'TO ',num2d,' IN FILE inclpar'
          write(*,'(a)') 'AND RECOMPILE...'
          stop
        endif
        NUM1D = MIF(203,ident)
        NUM0D = MIF(204,ident)
        write(*,'(a,4i4)') 'DIMENSIONS X/Y/Z: ',ix,jx,kx
        write(*,'(a,2i4)') 'NUMBER OF 2D/3D FIELDS: ',NUM2D,NUM3D
*
* -> PROJECTION, TRUE LATITUDE1, TRUE LATITUDE2,
*    CENTER LON/LAT, GRID DISTANCE COARSE DOMAIN,
*    POSITION OF NEST WITHIN MOTHER DOMAIN
*
* NOTE THAT THE INDEX ix GOES FROM SOUTH TO NORTH, jx FROM WEST
* TO EAST. IN FLEXPART, THE INDICES ARE DEFINED THE OTHER WAY
* ROUND...
*
        iproj=   mif(4,1)
        ixnest=  mif(104,1)
        jxnest=  mif(105,1)
        dxnest=  mrf(101,1)
        ixcoarse=mif(2,1)
        jxcoarse=mif(3,1)
        dxcoarse=mrf(1,1)
        xlonc   =mrf(3,1)
        ylatc   =mrf(2,1)
*        conef   =mrf(4,1)
        conef=0.716
        truelat1=mrf(5,1)
        truelat2=mrf(6,1)
        ypol    =mrf(7,1)
        xpos    =mrf(102,1)
        ypos    =mrf(103,1)
*
* CALCULATE LOWER LEFT/UPPER RIGHT GRID POINT
*
        xlow=-0.5*float(jxcoarse-1)*dxcoarse+(ypos-1.0)*dxcoarse
        ylow=-0.5*float(ixcoarse-1)*dxcoarse+(xpos-1.0)*dxcoarse
        call xytolamphi(xlow,ylow,xlonc,ylatc,truelat2,conef,
     &    xlon0,ylat0)
        xup = xlow+float(jxnest-1)*dxnest
        yup = ylow+float(ixnest-1)*dxnest
        call xytolamphi(xup ,yup ,xlonc,ylatc,truelat2,conef,
     &    xlon1,ylat1)

        write(*,*)
        write(*,'(a,2x,2f8.2)') 'LOWER LEFT GP:  ',xlon0,ylat0
        write(*,'(a,2x,2f8.2)') 'GRID CENTER:    ',xlonc,ylatc
        write(*,'(a,2x,2f8.2)') 'UPPER RIGHT GP: ',xlon1,ylat1
        write(*,*)

*
* -> VERTICAL DISCRETIZATION (Number of sigma levels, position)
*
        write(*,*)
        write(*,*) 'HALF SIGMA LEVELS: '
        write(*,*)
        do 45 k=1,kx
          sigma(k)=mrf(101+k,6)
45        write(*,'(i3,5x,f8.5)') k,sigma(k)
        write(*,*)
*
* -> BASE STATE FOR NH-RUN, PRESSURE OF THE MODEL TOP
*
        pp0 =mrf(2,6)
        ts0 =mrf(3,6)
        tlp =mrf(4,6)

        ptop=mrf(1,2)*100.0
*
* -> BEGINNING DATE, OUTPUT FREQUENCY, SIMULATION DURATION (Minutes)
*
        jmdstart=mif(16,6)*1000000+mif(15,6)*10000+mif(14,6)*100+
     &    mif(13,6)
        hmsstart=mif(12,6)*10000+mif(11,6)*100
        julstart=juldate(jmdstart,hmsstart)

        tstep_mins=mrf(302,6)
        deljul=dble(tstep_mins)/dble(1440)
        tmax_mins =mrf(308,6)

        write(*,'(a,i8.8,1x,i6.6)') 
     &    'BEGINNING DATE OF MODEL SIMULATION: ',jmdstart,hmsstart
        write(*,'(a,f8.0)') 'OUTPUT FREQUENCY [MINUTES]: ',tstep_mins
        write(*,'(a,f8.0)') 'SIMULATION TIME  [MINUTES]: ',tmax_mins
        write(*,*)

* READ MM5 RESULTS

        rewind(iunit)

* OPEN AVAILABLE FILE

        lenp=index(pathout(inest),' ')-1
        open(41,file=pathout(inest)(1:lenp)//'AVAILABLE',
     &    status='NEW',err=54)
        write(41,'(a)') 'DATE     TIME         FILENAME     SPECIFIC'//
     +'ATIONS'
        write(41,'(a)') 'YYYYMMDD HHMISS'
        write(41,'(a)') '________ ______      __________      ______'//
     +'____'
        close(41)

54      open(41,file=pathout(inest)(1:lenp)//'AVAILABLE',
     &    status='OLD',access='APPEND')

        open(42,file=pathout(inest)(1:lenp)//'GRID.TXT',
     &    status='unknown')
        write(42,'(i5,a)')   iproj,   '      PROJECTION'
        write(42,'(i5,a)')   jx,      '      GRID POINTS X'
        write(42,'(i5,a)')   ix,      '      GRID POINTS Y'
        write(42,'(i5,a)')   kx,      '      GRID POINTS Z'
        write(42,'(f5.2,a)') dxnest,  '      GRID DISTANCE'
        write(42,'(i5,a)')   jxcoarse,'      GRID POINTS X COARSE GRID'
        write(42,'(i5,a)')   ixcoarse,'      GRID POINTS Y COARSE GRID'
        write(42,'(f5.2,a)') dxcoarse,'      GRID DISTANCE COARSE GRID'
        write(42,'(f5.2,a)') ypos,    
     &    '      X POSITION OF GRID WITHIN MOTHER DOMAIN'
        write(42,'(f5.2,a)') xpos,    
     &    '      Y POSITION OF GRID WITHIN MOTHER DOMAIN'
        write(42,'(f8.2,a)') xlonc,   '   GRID CENTER LONGITUDE'
        write(42,'(f8.2,a)') ylatc,   '   GRID CENTER LATITUDE'
        write(42,'(f8.2,a)') xlon0,   '   LOWER LEFT LONGITUDE'
        write(42,'(f8.2,a)') ylat0,   '   LOWER LEFT LATITUDE'
        write(42,'(f8.2,a)') xlon1,   '   UPPER RIGHT LONGITUDE'
        write(42,'(f8.2,a)') ylat1,   '   UPPER RIGHT LATITUDE'
        write(42,'(f8.2,a)') truelat2,'   TRUE LATITUDE'
        write(42,'(f6.4,a)') conef,   '     CONE FACTOR'
        write(42,'(f8.1,a)') pp0,     '   REFERENCE SEA LEVEL PRESSURE'
        write(42,'(f8.1,a)') ptop,    '   MODEL TOP PRESSURE'
        write(42,'(f6.2,a)') ts0,     '     REFERENCE SEA LEVEL TEMP'
        write(42,'(f6.2,a)') tlp,     '     REFERENCE TEMP LAPSE RATE'
        do 46 k=1,kx
46        write(42,'(f8.5,a)') sigma(k),'   HALF SIGMA LEVEL'
        close(42)

        ifield=0
        do 55 ifile=1,numfile
          inum=inum+1
          iunit=60+inum

          if(ifile.gt.1) then
* CHECK FIT OF RESTART FILES
            read(iunit,end=997,err=997) mif,mrf,mifc,mrfc
            jmdrestart=mif(16,6)*1000000+mif(15,6)*10000+mif(14,6)*100+
     &        mif(13,6)
            hmsrestart=mif(12,6)*10000+mif(11,6)*100
            julrestart=juldate(jmdrestart,hmsrestart)
            if(mif(301,6).ne.1) goto 993
            if(julrestart.ne.julsum+deljul) goto 992
            rewind(iunit)
          endif

50        continue
          ifield=ifield+1
          call readmm5(iunit,num3d,num2d,num1d,num0d,ifield,
     &      ifieldskip,numpar2d,numpar3d,err,eof)
          if(err) goto 994
          if(eof) goto 55
          if(ifield.eq.1) then
            julsum=julstart
            call caldate(julsum,jmd,hms)
          else
            julsum=julsum+deljul
            call caldate(julsum,jmd,hms)
          endif
          if(hms.gt.235959) then
            call caldate(julsum+dble(1./86400.),jmd,hms)
            hms=0
          endif
          write(*,'(a,i8.8,1x,i6.6)')
     &      'EXTRACTING DATA FOR DATE: ',jmd,hms

* WRITE OUT IN FLEXPART-NEEDED FORMAT

          if(ifield.gt.ifieldskip)
     &      call writeout(jmd,hms,fid,pathout(inest),41,numpar2d,
     &                    numpar3d)

          goto 50
55      continue
60      continue

1000  continue

      close(41)
      write(*,*)
      write(*,*) 'CONGRATULATIONS FOLKS !'
      write(*,*) 'FINISHED DATA CONVERSION ROUTINES WITHOUT CRASH'
      stop

999   write(*,*) 'SORRY, FOLKS, BUT: '
      write(*,*) 'EITHER, YOUR FILE "CONTROL" DOES NOT EXIST ...'
      write(*,*) '...OR IT EXISTS BUT IS CORRUPT'
      write(*,*) 'PLEASE CHECK !!!'
      stop

998   write(*,*) 'SORRY, FOLKS, BUT: '
      write(*,*) 'EITHER, YOUR FILE "PARAMETER" DOES NOT EXIST ...'
      write(*,*) '...OR IT EXISTS BUT IS CORRUPT'
      write(*,*) 'PLEASE CHECK !!!'
      stop

997   write(*,'(a)') 'SORRY, FOLKS, BUT YOUR FILE '
      len=index(fnmm5(inest,1),' ')-1
      write(*,'(a)') fnmm5(inest,1)(1:len)
      write(*,'(a)') 'DOES NOT EXIST OR IS CORRUPT. PLEASE CHECK'
      stop

996   write(*,'(a)') 'SORRY, FOLKS, BUT YOUR FILE '
      len=index(fnmm5(inest,1),' ')-1
      write(*,'(a)') fnmm5(inest,1)(1:len)
      write(*,'(a)') 'DOES NOT CONTAIN MM5 OUTPUT. PLEASE CHECK'
      stop

995   write(*,'(a)') 'SORRY, FOLKS, BUT FLEXPART DOES NOT LIKE'
      write(*,'(a)') 'HYDROSTATIC MM5 RUNS...'
      stop

994   write(*,'(a)') 'SORRY, FOLKS, BUT YOUR FILE '
      len=index(fnmm5(inest,ifile),' ')-1
      write(*,'(a)') fnmm5(inest,ifile)(1:len)
      write(*,'(a)') 'DOES NOT EXIST OR IS CORRUPT. PLEASE CHECK'
      stop

993   write(*,'(a)') 'SORRY, FOLKS, BUT YOUR FILE '
      len=index(fnmm5(inest,ifile),' ')-1
      write(*,'(a)') fnmm5(inest,ifile)(1:len)
      write(*,'(a)') 'IS NO RESTART FILE !!!'
      stop

992   write(*,'(a)') 'SORRY, FOLKS. YOUR FILE '
      len=index(fnmm5(inest,ifile),' ')-1
      write(*,'(a)') fnmm5(inest,ifile)(1:len)
      write(*,'(a)') 'IS  A RESTART FILE, BUT THE DATES'
      write(*,'(a)') 'DO NOT FIT...'
      call caldate(julsum+deljul,jmd,hms)
      write(*,'(a,i8.1,1x,i6.6)') 'EXPECTED: ',jmd,hms
      write(*,'(a,i8.1,1x,i6.6)') 'FOUND:    ',jmdrestart,hmsrestart
      stop

      end
